
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ForecastsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const forecasts = await db.forecasts.create(
            {
                id: data.id || undefined,
        
        forecast_name: data.forecast_name
        ||
        null
            ,
            
        horizon: data.horizon
        ||
        null
            ,
            
        start_date: data.start_date
        ||
        null
            ,
            
        end_date: data.end_date
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        starting_cash: data.starting_cash
        ||
        null
            ,
            
        projected_ending_cash: data.projected_ending_cash
        ||
        null
            ,
            
        runway_months: data.runway_months
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await forecasts.setWorkspace( data.workspace || null, {
            transaction,
        });
        
        await forecasts.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return forecasts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const forecastsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                forecast_name: item.forecast_name
            ||
            null
            ,
            
                horizon: item.horizon
            ||
            null
            ,
            
                start_date: item.start_date
            ||
            null
            ,
            
                end_date: item.end_date
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                starting_cash: item.starting_cash
            ||
            null
            ,
            
                projected_ending_cash: item.projected_ending_cash
            ||
            null
            ,
            
                runway_months: item.runway_months
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const forecasts = await db.forecasts.bulkCreate(forecastsData, { transaction });

        // For each item created, replace relation files
        

        return forecasts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const forecasts = await db.forecasts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.forecast_name !== undefined) updatePayload.forecast_name = data.forecast_name;
        
        
        if (data.horizon !== undefined) updatePayload.horizon = data.horizon;
        
        
        if (data.start_date !== undefined) updatePayload.start_date = data.start_date;
        
        
        if (data.end_date !== undefined) updatePayload.end_date = data.end_date;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.starting_cash !== undefined) updatePayload.starting_cash = data.starting_cash;
        
        
        if (data.projected_ending_cash !== undefined) updatePayload.projected_ending_cash = data.projected_ending_cash;
        
        
        if (data.runway_months !== undefined) updatePayload.runway_months = data.runway_months;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await forecasts.update(updatePayload, {transaction});

        
        
        if (data.workspace !== undefined) {
            await forecasts.setWorkspace(
              
              data.workspace,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await forecasts.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return forecasts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const forecasts = await db.forecasts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of forecasts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of forecasts) {
                await record.destroy({transaction});
            }
        });


        return forecasts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const forecasts = await db.forecasts.findByPk(id, options);

        await forecasts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await forecasts.destroy({
            transaction
        });

        return forecasts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const forecasts = await db.forecasts.findOne(
            { where },
            { transaction },
        );

        if (!forecasts) {
            return forecasts;
        }

        const output = forecasts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.forecast_scenarios_forecast = await forecasts.getForecast_scenarios_forecast({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        output.workspace = await forecasts.getWorkspace({
            transaction
        });
        
        
        output.organizations = await forecasts.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.workspaces,
        as: 'workspace',
        
        where: filter.workspace ? {
          [Op.or]: [
            { id: { [Op.in]: filter.workspace.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.workspace.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.forecast_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'forecasts',
                        'forecast_name',
                        filter.forecast_name,
                    ),
                };
            }
            
            if (filter.currency) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'forecasts',
                        'currency',
                        filter.currency,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            start_date: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    end_date: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.start_dateRange) {
                const [start, end] = filter.start_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    start_date: {
                    ...where.start_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    start_date: {
                    ...where.start_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.end_dateRange) {
                const [start, end] = filter.end_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    end_date: {
                    ...where.end_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    end_date: {
                    ...where.end_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.starting_cashRange) {
                const [start, end] = filter.starting_cashRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    starting_cash: {
                    ...where.starting_cash,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    starting_cash: {
                    ...where.starting_cash,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.projected_ending_cashRange) {
                const [start, end] = filter.projected_ending_cashRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    projected_ending_cash: {
                    ...where.projected_ending_cash,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    projected_ending_cash: {
                    ...where.projected_ending_cash,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.runway_monthsRange) {
                const [start, end] = filter.runway_monthsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    runway_months: {
                    ...where.runway_months,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    runway_months: {
                    ...where.runway_months,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.horizon) {
                where = {
                    ...where,
                horizon: filter.horizon,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.forecasts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'forecasts',
                        'forecast_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.forecasts.findAll({
            attributes: [ 'id', 'forecast_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['forecast_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.forecast_name,
        }));
    }

    
};

